# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'searchwindow.ui'
#
# Created: mié nov 16 10:43:00 2005
#      by: The PyQt User Interface Compiler (pyuic) 3.14.1
#
# WARNING! All changes made in this file will be lost!


from qt import *
from searchwindow import SearchWindow
from smartdjpreferences import SmartDJPreferences
import sys
import logging
logger = logging.getLogger("PyQt UI")
from threading import Thread,Lock
from songanalysiscommon import *
from dcopamarok import dcop_amarok,DcopAmarokFailed
import time
import os

def _ppiholder(): pass
def get_plugin_public_interface(): return _ppiholder.pi
def _set_plugin_public_interface(pi): _ppiholder.pi = pi

app = None

# this code is now shared between Qt and GTK+ interface, find a way to librarize it so we don't have to modify it everywhere
get_ui_config_lock = Lock()

def get_ui_config():
	global get_ui_config_lock
	get_ui_config_lock.acquire()
	try:
		c = get_plugin_public_interface().get_config()
		def has_key(object,key): return object.has_key(key)
		if not has_key(c,"ui"):
			c["ui"] = dict()
		if not has_key(c["ui"],"SearchWindow"):
			c["ui"]["SearchWindow"] = dict()
		if not has_key(c["ui"]["SearchWindow"],"height"):
			c["ui"]["SearchWindow"]["height"] = 350
		if not has_key(c["ui"]["SearchWindow"],"width"):
			c["ui"]["SearchWindow"]["width"] = 600
		if not has_key(c["ui"]["SearchWindow"],"columns"):
			c["ui"]["SearchWindow"]["columns"] = [ ["File name",1,True,False,120],["Folder",2,True,False,300],["Artist",3,True,True,110],["Album",4,True,True,110],["Title",5,True,True,110],["Similarity",6,False,True],["Tempo",7,False,True] ]
		if not has_key(c["ui"]["SearchWindow"],"num_results"):
			c["ui"]["SearchWindow"]["num_results"] = 10
		if not has_key(c["ui"]["SearchWindow"],"tempo_source"):
			c["ui"]["SearchWindow"]["tempo_source"] = CHOSEN_SONG_TEMPO
		if not has_key(c["ui"]["SearchWindow"],"fixed_tempo"):
			c["ui"]["SearchWindow"]["fixed_tempo"] = 120
		if not has_key(c["ui"]["SearchWindow"],"weighting"):
			c["ui"]["SearchWindow"]["weighting"] = 1.0
	
		return c["ui"]
	finally:
		get_ui_config_lock.release()

def tounicode(string): return unicode(string,sys.getfilesystemencoding())

# async operation!!!
from threading import currentThread, Lock
class AsyncOperation(QTimer):
	lock = Lock()
	def __init__(self,parent,time,func_call,*args):
		"""time is in seconds or fractions thereof"""
		self.lock.acquire()
		qApp.lock()
		try:
			QTimer.__init__(self,parent)
			self.func_call = func_call
			self.args = args
			logger.debug("Preparing %s in thread %s",self.func_call.__name__,currentThread())
			QObject.connect(self,SIGNAL("timeout(void)"),self.on_timeout)
			self.start(int(time*1000),True)
		finally:
			qApp.unlock()
			self.lock.release()
	
	def on_timeout(self):
		logger.debug("Running %s in thread %s",self.func_call.__name__,currentThread())
		args = self.args
		try: self.func_call(*args)
		except: logger.exception("Operation threw an exception")

class SyncOperation(AsyncOperation):
	def __init__(self,parent,func_call,*args):
		AsyncOperation.__init__(self,parent,0,func_call,*args)
# end async operation



class OSearchWindow(SearchWindow):
	
	def __init__(self,parent):
		SearchWindow.__init__(self,parent,fl=Qt.WDestructiveClose)
		self.__stopsearch = False
		
		resultsView = self.child("resultsView",None,True)
		resultsView.removeColumn(0)
		resultsView.addColumn("Path")
		resultsView.addColumn("File name")
		resultsView.addColumn("Folder")
		resultsView.addColumn("Artist")
		resultsView.addColumn("Album")
		resultsView.addColumn("Title")
		resultsView.addColumn("Similarity")
		resultsView.addColumn("Tempo")
		for a in [0,1,2,3,4,5]: resultsView.setColumnWidthMode(a,QListView.Manual)
		for a in [3,4,5]: resultsView.setColumnWidth(a,155)
		resultsView.setSorting(6,False)
		resultsView.hideColumn(0)
		resultsView.hideColumn(1)
		resultsView.hideColumn(2)
		
		def dragObject(self):
			strlist = []
			strlist.append (str(self.selectedItem().text(0)))
			d = QUriDrag(strlist,self)
			return d
		
		import new
		resultsView.dragObject = new.instancemethod( dragObject , resultsView, QListView )
		
	def stopSearch(self):
		self.__stopsearch = True
	
	def search(self,filename):
		self.filename = filename
		song = get_plugin_public_interface().get_song(filename)
		at = song.artist + " - " + song.title
		if at.startswith(" - "): at = at[3:]
		self.setCaption(tounicode(at + " - amaroK Smart DJ search"))
		self.performSearch()
	
	def performSearch(self):
		logger.debug("Searching similar songs to %s",self.filename)

		start_file = self.filename
		
		def reflectSearching(trueorfalse):
			
			disableduringsearch = [
			"buttonSearch",
			"tempoSpectrumBalance",
			"useSelectedSongTempo",
			"useFixedTempo",
			"numResults",
			]
			enableduringsearch = [
			"buttonStop",
			]
			
			for w in disableduringsearch:
				self.child(w,None,True).setDisabled(trueorfalse)
			for w in enableduringsearch:
				self.child(w,None,True).setEnabled(trueorfalse)
				
			if trueorfalse: #if we're searching
				self.child("fixedTempo",None,True).setEnabled(False)
			else:
				self.child("fixedTempo",None,True).setEnabled(self.child("useFixedTempo",None,True).isChecked())
		
		reflectSearching(True)
		resultsView = self.child("resultsView",None,True)
		resultsView.clear()
		
		app.processEvents()
		
		spectrum_weight = self.child("tempoSpectrumBalance",None,True).value() / 10.0
		tempo_weight = 2 - spectrum_weight
		limit = self.child("numResults",None,True).value()
		if self.child("useFixedTempo",None,True).isChecked():
			fixed_tempo = self.child("fixedTempo",None,True).value()
		else: fixed_tempo = None

		logger.debug("Searching for %s max %s results with tempo/spectrum %s/%s",start_file,limit,tempo_weight,spectrum_weight)
		
		
		results = get_plugin_public_interface().get_similar_songs(
			start_file,spectrum_weight,tempo_weight,limit,fixed_tempo=fixed_tempo)
		
		app.processEvents()

		if self.__stopsearch:
			self.__stopsearch = False
			reflectSearching(False)
			return
			
		resultsView.setFocus()
		
		def actual_put(resultsView,r,artist,album,title):
			class MyListViewItem(QListViewItem):
				def key(self,column,ascending):
					if column in [6,7]:
						key = "0" * (10-len(self.text(column))) + str(self.text(column))
						return QString(key)
					else: return self.text(column)
			listitem = MyListViewItem(resultsView,tounicode(r[0]),tounicode(os.path.basename(r[0])),
						tounicode(os.path.dirname(r[0])),tounicode(artist),tounicode(album),
						tounicode(title),"%.1f"%round(r[1],1),"%.1f"%round(r[2],1))
			listitem.setDragEnabled(True)
		
		def do_all(resultsView,results):
			maxcompat = max( [ r[1] for r in results] )
			for r in results:
				if self.__stopsearch:
					self.__stopsearch = False
					break
				get_song = get_plugin_public_interface().get_song
				r[1] = r[1] *100.0 / maxcompat
				song_object = get_song(r[0])
				app.processEvents()
				artist = song_object.artist
				app.processEvents()
				album = song_object.album
				app.processEvents()
				title = song_object.title
				app.processEvents()
				actual_put(resultsView,r,artist,album,title)
				app.processEvents()
			
		def _do_all(resultsView,results):
			try: do_all(resultsView,results)
			except DcopAmarokFailed,e:
				logger.debug("amaroK has gone unexpectedly",exc_info=True)
				self.reject() # attempt to close the dialog synchronously
			except: logger.exception("Something went bad")
			
		_do_all(resultsView,results)
		reflectSearching(False)
		

class OSmartDJPreferences(SmartDJPreferences):
	fully_initialized = False
	
	def __init__(self,parent):
		SmartDJPreferences.__init__(self,parent,fl=Qt.WDestructiveClose)
		
		c = get_plugin_public_interface().get_config()["super_dynamic_mode"]
		def w(name): return self.child(name,None,True)
		
		w("enableAutoDJ").setChecked(c["enabled"])
		w("topChoices").setValue(c["top_choices"])
		w("upcomingSongs").setValue(c["upcoming_songs"])
		
		if c["choice_mechanism"] == SONG_IM_LISTENING:
			w("currentlyListeningSong").setChecked(True)
		elif c["choice_mechanism"] == SONG_IM_LISTENING_WANDER:
			w("currentlyListeningSongWander").setChecked(True)
		elif c["choice_mechanism"] == LAST_SONG_IN_PLAYLIST:
			w("lastSongInPlaylist").setChecked(True)
		else: assert(False)
		tempo_weight,spectrum_weight = (c["tempo_weight"],c["spectrum_weight"])
		w("tempoSpectrumBalance").setValue(int(round(spectrum_weight*10,0)))
		
		combobox = w("playlistComboBox")
		def refill(self): # fixme esto debe bloquear las señales del combobox y proceder a hacer el refil, para posteriormente volver a tomar el valor que estaba seleccionado originalmente, SI ES QUE existe, y si no, ninguno.
			self.clear()
			pnames = ["The entire collection"]
			pnames.extend([ p.name for p in
				get_plugin_public_interface().get_smart_playlist_collection().playlists ])
			for pname in pnames: self.insertItem(tounicode(pname))
		import new
		combobox.refill = new.instancemethod( refill, combobox, QComboBox )
		
		combobox.refill()
		
		if c["source_playlist"] is None:
			combobox.setCurrentText("The entire collection")
		else:
			combobox.setCurrentText(c["source_playlist"])
		
		QTimer.singleShot(500,self.updateStatus)
		timer = QTimer(self)
		QObject.connect(timer,SIGNAL("timeout(void)"),self.updateStatus)
		timer.start(5000)
		
		self.fully_initialized = True
	
	def configChangedByUser(self):
		if not self.fully_initialized: return
		logger.debug("Configuration changed by user")
		
		c = get_plugin_public_interface().get_config()["super_dynamic_mode"]
		def w(name): return self.child(name,None,True)
		
		c["enabled"] = w("enableAutoDJ").isChecked()
		c["top_choices"] = w("topChoices").value()
		c["upcoming_songs"] = w("upcomingSongs").value()
		
		if w("currentlyListeningSong").isChecked():
			c["choice_mechanism"] = SONG_IM_LISTENING
		elif w("currentlyListeningSongWander").isChecked():
			c["choice_mechanism"] = SONG_IM_LISTENING_WANDER
		elif w("lastSongInPlaylist").isChecked():
			c["choice_mechanism"] = LAST_SONG_IN_PLAYLIST
		else: assert(False)
		
		c["spectrum_weight"] = float(w("tempoSpectrumBalance").value()) / 10.0
		c["tempo_weight"] = 2.0 - c["spectrum_weight"] 
		
		combobox = w("playlistComboBox")
		
		if combobox.currentItem() == 0:
			c["source_playlist"] = None
		else:
			c["source_playlist"] = str(combobox.currentText())
		
		get_plugin_public_interface().notify_config_changed()
		logger.debug("New configuration: %s",c)
	
	
	def updateStatus(self):
		try:
			current_song = get_plugin_public_interface().get_current_song()
			app.processEvents()
			pqueue_count = get_plugin_public_interface().get_priority_queue_count()
			app.processEvents()
			total = get_plugin_public_interface().get_total_songs()
			app.processEvents()
			left = get_plugin_public_interface().get_remaining_songs()
			progress = ( float(total) - float(left) ) / float(total)
			
			def w(name): return self.child(name,None,True)
			if current_song:
				w("songCurrentlyAnalyzing").setText(tounicode("Analyzing %s"%current_song))
				string = "%s of %s songs (%.1f%%) pending analysis"%(left,total,100-progress*100)
			else:
				w("songCurrentlyAnalyzing").setText(tounicode("Idle.  All songs have been analyzed."))
				string = "%s songs analyzed"%(total)
			if pqueue_count:
				if pqueue_count != 1: s = "s"
				else: s = ""
				w("priorityQueueLength").setText(tounicode("%s song%s in the analysis priority queue"%(pqueue_count,s)))
			else:
				w("priorityQueueLength").setText(tounicode("No songs in the analysis priority queue"))
			
			w("analysisProgress").setProgress(int(progress*1000))
			w("analysisProgressText").setText(tounicode(string))
		except DcopAmarokFailed,e:
			logger.debug("amaroK is unexpectedly gone")


# my own qt app
class UIApp(QApplication):
	def __init__(self):
		QApplication.__init__(self,sys.argv)
		self.mainWindow = QMainWindow()
		self.setMainWidget(self.mainWindow)
		
		def testdrive():
			while True:
				time.sleep(2)
				print "children:" , self.mainWindow.children()[-1]
# 		t=Thread(target=testdrive)
# 		t.start()
		
	def search(self,files):
		for file in files:
			SyncOperation(self,self._search_sync,file)
	
	def _search_sync(self,file):
		search_window = OSearchWindow(self.mainWindow)
		try:
			title = None
			message = None
			search_window.show()
			search_window.search(file)
		except NotAnalyzedYet,e:
			search_window.reject()
			title = "Cannot search for similar songs yet"
			message = "The selected song (%s) has not yet been analyzed, and thus it cannot be compared to other songs in your collection.  Please right-click the song, select Smart DJ->Analyze selection now, and try again in 30 seconds."%file
			
		except UnAnalyzable,e:
			search_window.reject()
			title = "Analysis on the selected song failed"
			message = "The selected song (%s) could not be analyzed, probably because its compression format was not understood by songanalysis."%file
			
		except DcopAmarokFailed,e:
			logger.debug("amaroK has gone unexpectedly",exc_info=True)
			search_window.reject()
			return
			
		if title and message:
			m = QMessageBox(title,message,QMessageBox.Information,QMessageBox.Ok,
			QMessageBox.NoButton,QMessageBox.NoButton,self.mainWindow,None,True)
			m.setTextFormat(Qt.RichText)
			m.show()
	
	def show_configuration(self):
		SyncOperation(self,self._show_configuration_sync)
			
	def _show_configuration_sync(self):
		prefs = OSmartDJPreferences(self.mainWindow)
		prefs.show()
# 			print "Now killing dialog 4ever"
# 			SyncOperation(self,delattr,self,"prefs")

def _run_ui_loop():
	global app
	try:
		logger.debug("Running ui loop in thread: %s",currentThread())
		app = UIApp()
		app.exec_loop()
	except:
		logger.exception("Something went wrong in the UI loop thread")


#------------ public implementation starts ----------------------

def initialize(public_interface):
	logger.debug("Initializing with public interface %s",public_interface)
	_set_plugin_public_interface(public_interface)
	t = Thread(target=_run_ui_loop)
	t.setName("UI thread")
	t.setDaemon(True)
	t.start()

def search(start_files):
	""" Receive a Python list of file paths (NOT URLs)"""
# 	gobject.idle_add(_search_sync,start_files)
	while app is None: time.sleep(.3)
	app.search(start_files)

def show_configuration():
	""" Receive a Python list of file paths (NOT URLs)"""
# 	gobject.idle_add(_show_config_sync)
	while app is None: time.sleep(.3)
	app.show_configuration()


# -------------- debugging code, do not read me -------------------------

if __name__ == "__main__":
	logging.basicConfig()
	logger.setLevel(logging.DEBUG)
	initialize(None)
	time.sleep(5)
	print "Now exiting"
# 	app = UIApp()
# 	
# 	app.exec_loop()